import { FirestoreOptions, firestoreOptions } from '@posva/vuefire-core';
import { firestore } from 'firebase';
import { ActionContext, Action } from 'vuex';
export { firestoreOptions };
interface FirestoreActionContext<S, R> extends ActionContext<S, R> {
    bindFirestoreRef(key: string, ref: firestore.Query | firestore.CollectionReference, options?: FirestoreOptions): Promise<firestore.DocumentData[]>;
    bindFirestoreRef(key: string, ref: firestore.DocumentReference, options?: FirestoreOptions): Promise<firestore.DocumentData>;
    unbindFirestoreRef(key: string): void;
}
export declare function firestoreAction<S, R>(action: (context: FirestoreActionContext<S, R>, payload: any) => any): Action<S, R>;
